/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.seguridad;

import com.rjconsultores.ventaboletos.entidad.Autorizacion;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderAutorizacion;
import java.util.HashMap;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Administrador
 */
@Controller("busquedaAutorizacionController")
@Scope("prototype")
public class BusquedaAutorizacionController extends MyGenericForwardComposer {

    @Autowired
    private transient PagedListWrapper<Autorizacion> plwAutorizacion;
    private MyListbox autorizacionList;
    private Paging pagingAutorizacion;
    private Textbox txtNombAutorizacion;
    private Textbox txtDescAutorizacion;

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);

        autorizacionList.setItemRenderer(new RenderAutorizacion());
        autorizacionList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                Autorizacion s = (Autorizacion) autorizacionList.getSelected();
                verAutorizacion(s);
            }
        });

        refreshLista();

        txtNombAutorizacion.focus();
    }

    private void verAutorizacion(Autorizacion fs) {
        if (fs == null) {
            return;
        }

        Map args = new HashMap();
        args.put("autorizacion", fs);
        args.put("autorizacionList", autorizacionList);

        openWindow("/gui/seguridad/editarAutorizacion.zul",
                Labels.getLabel("editarAutorizacionController.window.title"), args, MODAL);
    }

    private void refreshLista() {
        HibernateSearchObject<Autorizacion> menuBusqueda =
                new HibernateSearchObject<Autorizacion>(Autorizacion.class,
                pagingAutorizacion.getPageSize());

        menuBusqueda.addFilterLike("nombautorizacion",
                "%" + txtNombAutorizacion.getText().trim().concat("%"));
        menuBusqueda.addFilterLike("descautorizacion",
                "%" + txtDescAutorizacion.getText().trim().concat("%"));

        menuBusqueda.addSortAsc("descautorizacion");
        menuBusqueda.addFilterEqual("activo", Boolean.TRUE);

        plwAutorizacion.init(menuBusqueda, autorizacionList, pagingAutorizacion);

        if (autorizacionList.getData().length == 0) {
            try {
                Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
                        Labels.getLabel("busquedaAutorizacionController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            } catch (InterruptedException ex) {
            }
        }
    }

    public void onClick$btnPesquisa(Event ev) {
        refreshLista();
    }

    public void onClick$btnRefresh(Event ev) {
        refreshLista();
    }

    public void onClick$btnNovo(Event ev) {
        verAutorizacion(new Autorizacion());
    }
}
